<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/


chdir('../../');

//include("./include/auth.php");
include("./include/config.php");
include_once("./lib/utility.php");

$host_actions = array(
	1 => "Delete"
	);

/* set default action */
if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }


docs_setup_db ();



switch ($_REQUEST["action"]) {
	case 'save':
		form_save();

		break;
	case 'actions':
		form_actions();

		break;
	case 'edit':
		include_once("./include/top_header.php");

		template_edit();

		include_once("./include/bottom_footer.php");
		break;
	default:
		include_once("./include/top_header.php");

		template();

		include_once("./include/bottom_footer.php");
		break;
}


function form_actions() {
	global $colors, $config, $host_actions;

	/* if we are to save this form, instead of display it */
	if (isset($_POST["selected_items"])) {
		$selected_items = unserialize(stripslashes($_POST["selected_items"]));

		if ($_POST["drp_action"] == "1") { /* delete */
			db_execute("delete from plugin_docs where " . array_to_sql_or($selected_items, "id"));
		}

		header("Location: docs.php");
		exit;
	}

	/* setup some variables */
	$host_list = ""; $i = 0;

	/* loop through each of the host templates selected on the previous page and get more info about them */
	while (list($var,$val) = each($_POST)) {
		if (ereg("^chk_([0-9]+)$", $var, $matches)) {
			/* ================= input validation ================= */
			input_validate_input_number($matches[1]);
			/* ==================================================== */

			$host_list .= "<li>" . db_fetch_cell("select title from plugin_docs  where id=" . $matches[1]) . "<br>";
			$host_array[$i] = $matches[1];
		}

		$i++;
	}

	include_once("./include/top_header.php");

	html_start_box("<strong>" . $host_actions{$_POST["drp_action"]} . "</strong>", "60%", $colors["header_panel"], "3", "center", "");

	print "<form action='docs.php' method='post'>\n";

	if ($_POST["drp_action"] == "1") { /* delete */
		print "	<tr>
				<td class='textArea' bgcolor='#" . $colors["form_alternate1"]. "'>
					<p>Are you sure you want to delete the following Documents?</p>
					<p>$host_list</p>
				</td>
			</tr>\n
			";
	}

	if (!isset($host_array)) {
		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one document.</span></td></tr>\n";
		$save_html = "";
	}else{
		$save_html = "<input type='image' src='" . $config['url_path'] . "images/button_yes.gif' alt='Save' align='absmiddle'>";
	}

	print "	<tr>
			<td align='right' bgcolor='#eaeaea'>
				<input type='hidden' name='action' value='actions'>
				<input type='hidden' name='selected_items' value='" . (isset($host_array) ? serialize($host_array) : '') . "'>
				<input type='hidden' name='drp_action' value='" . $_POST["drp_action"] . "'>
				<a href='docs.php'><img src='" . $config['url_path'] . "images/button_no.gif' alt='Cancel' align='absmiddle' border='0'></a>
				$save_html
			</td>
		</tr>
		";

	html_end_box();

	include_once("./include/bottom_footer.php");
}


function form_save() {
	if (isset($_POST["id"])) {
		input_validate_input_number(get_request_var("id"));
		$save["id"] = $_POST["id"];
		$save["title"] = sql_sanitize($_POST["title"]);
		$save["data"] = sql_sanitize($_POST["data"]);
		$save["updated"] = time();
		if ($save["id"] == 0) {
			$save["creator"] = $_SESSION['sess_user_id'];
		}
		$save["updatedby"] = $_SESSION['sess_user_id'];

		if (!is_error_message()) {
			$id = sql_save($save, "plugin_docs");

			if ($id) {
				raise_message(1);
			}else{
				raise_message(2);
			}
		}

		if (is_error_message() || empty($_POST["id"])) {
			header("Location: docs.php?id=" . (empty($id) ? $_POST["id"] : $id));
		}else{
			header("Location: docs.php");
		}
	}
}

function template_edit() {
	global $colors, $config;

	/* ================= input validation ================= */
	input_validate_input_number(get_request_var("id"));
	/* ==================================================== */

	display_output_messages();

	if (!empty($_GET["id"])) {
		$document = db_fetch_row("select * from plugin_docs where id=" . $_GET["id"]);
		$id = $_GET['id'];
	}else{
		$_GET["id"] = 0;
		$id = 0;
		$document = array('title' => '', 'data' => '');
	}

	print '<script language="javascript" type="text/javascript" src="jscripts/tiny_mce/tiny_mce.js"></script>
	<script language="javascript" type="text/javascript">
	tinyMCE.init({
	mode : "textareas",
	theme : "advanced",
	plugins: "advimage,contextmenu,advlink,advhr",
	theme_advanced_buttons1 : "fontselect,fontsizeselect,formatselect,sub,sup",
	theme_advanced_buttons2 : "bold,italic,underline,separator,justifyleft,justifycenter,justifyright,justifyfull,separator,bullist,numlist,outdent,indent,separator,undo,redo,link,unlink,image,advhr",
	theme_advanced_buttons3 : "",
	theme_advanced_toolbar_location : "top",
	theme_advanced_toolbar_align : "left",
	extended_valid_elements : "a[name|href|target|title|onclick],img[class|src|border=0|alt|title|hspace|vspace|width|height|align|onmouseover|onmouseout|name],hr[class|width|size|noshade],font[face|size|color|style],span[class|align|style]"
	});
	</script>';

	print '<br><br><center>';
	html_start_box("<strong>Document Editor</strong>", "", $colors["header"], "3", "center", "");
	print "<tr><td><table width='100%'>";

	print '<form action="' . $config['url_path'] . 'plugins/docs/docs.php" method=POST name=docs>';


	print '<tr><td width=60><b>Title</b>:</td><td>';
	print "<input type=hidden name=id value='$id'>";
	print "<input type=text name=title maxlength=255 size=100 value='" . $document['title'] . "'>";
	print "</td></tr>";

	print '<tr><td colspan=2>';
	print "<textarea cols=100 rows=35 name='data'>" . $document['data'] . "</textarea>";
	print "</td></tr>";


	print "</table></td></tr>";
	html_end_box();

	form_save_button("docs.php");
}


function template() {
	global $colors, $host_actions;

	/* clean up sort_column */
	if (isset($_REQUEST["sort_column"])) {
		$_REQUEST["sort_column"] = sanitize_search_string(get_request_var("sort_column"));
	}

	/* clean up search string */
	if (isset($_REQUEST["sort_direction"])) {
		$_REQUEST["sort_direction"] = sanitize_search_string(get_request_var("sort_direction"));
	}

	/* remember these search fields in session vars so we don't have to keep passing them around */
	load_current_session_value("sort_column", "sess_docs_template_column", "title");
	load_current_session_value("sort_direction", "sess_docs_template_sort_direction", "ASC");

	display_output_messages();

	$display_text = array(
		"title" => array("Title", "ASC"),
		"creator" => array("Creator", "ASC"),
		"updated" => array("Last Updated", "ASC"),
		"updatedby" => array("Updated By", "ASC"),);

	html_start_box("<strong>Documents</strong>", "98%", $colors["header"], count($display_text)+1, "center", "docs.php?action=edit");

	html_header_sort_checkbox($display_text, $_REQUEST["sort_column"], $_REQUEST["sort_direction"]);

	$documents = db_fetch_assoc("SELECT * FROM plugin_docs ORDER BY " . $_REQUEST['sort_column'] . " " . $_REQUEST['sort_direction']);

	$results = db_fetch_assoc("SELECT id, username FROM user_auth");
	$users = array();
	foreach ($results as $user) {
		$users[$user['id']] = $user['username'];
	}

	$i = 0;
	if (sizeof($documents) > 0) {
	foreach ($documents as $document) {
		form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
			?>
			<td>
				<a class="linkEditMain" href="docs.php?action=edit&id=<?php print $document["id"];?>"><?php print $document['title']; ?></a>
			</td>
			<td>
				<?php (isset($users[$document['creator']]) ? print $users[$document['creator']] : "Unknown"); ?>
			</td>
			<td>
				<?php print date("F j, Y, g:i a", $document['updated']); ?>
			</td>
			<td>
				<?php (isset($users[$document['updatedby']]) ? print $users[$document['updatedby']] : "Unknown"); ?>

			</td>
			<td style="<?php print get_checkbox_style();?>" width="1%" align="right">
				<input type='checkbox' style='margin: 0px;' name='chk_<?php print $document["id"];?>' title="<?php print $document["title"];?>">
			</td>
		</tr>
	<?php
	}
	}else{
		print "<tr><td><em>No Documents</em></td></tr>\n";
	}
	html_end_box(false);

	/* draw the dropdown containing a list of available actions for this form */
	draw_actions_dropdown($host_actions);

	print "</form>\n";
}


?> 
