<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2007 The Cacti Group                                      |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | Cacti: The Complete RRDTool-based Graphing Solution                     |
 +-------------------------------------------------------------------------+
 | This code is designed, written, and maintained by the Cacti Group. See  |
 | about.php and/or the AUTHORS file for specific developer information.   |
 +-------------------------------------------------------------------------+
 | http://www.cacti.net/                                                   |
 +-------------------------------------------------------------------------+
*/

function plugin_init_docs() {
	global $plugin_hooks;
	$plugin_hooks['config_arrays']['docs'] = 'docs_config_arrays';
	$plugin_hooks['draw_navigation_text']['docs'] = 'docs_draw_navigation_text';
}

function docs_version () {
	return array( 'name' 		=> 'docs',
			'version' 	=> '0.1',
			'longname'	=> 'Documents',
			'author'	=> 'Jimmy Conner',
			'homepage'	=> 'http://cactiusers.org',
			'email'		=> 'jimmy@sqmail.org',
			'url'		=> 'http://cactiusers.org/cacti/versions.php'
			);
} 

function docs_config_arrays() {
	global $menu, $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[190] = 'Manage Documents';
	$user_auth_realm_filenames['docs.php'] = 190;
	$menu["Management"]['plugins/docs/docs.php'] = "Documents";

}

function docs_draw_navigation_text ($nav) {
	$nav["docs.php:"] = array("title" => "Documents", "mapping" => "index.php:", "url" => "docs.php", "level" => "1");
	$nav["docs.php:edit"] = array("title" => "Edit", "mapping" => "docs.php:", "url" => "docs.php", "level" => "2");
	$nav["docs.php:actions"] = array("title" => "Delete", "mapping" => "docs.php:", "url" => "docs.php", "level" => "2");
	return $nav;
}

function docs_setup_db () {

	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show tables from `" . $database_default . "`";

	$result = db_fetch_assoc($sql) or die (mysql_error());

	$tables = array();
	$sql = array();

	foreach($result as $index => $arr) {
		foreach ($arr as $t) {
			$tables[] = $t;
		}
	}

	if (!in_array('plugin_docs', $tables)) {
		$sql[] = "CREATE TABLE `plugin_docs` (
 			  `id` int(11) NOT NULL AUTO_INCREMENT,
 			  `title` varchar(255) default '',
 			  `data` BLOB,
 			  `updated` int(11) NOT NULL default '0',
			  `creator` varchar(255) NOT NULL default '',
			  `updatedby` varchar(255) NOT NULL default '',
 			  PRIMARY KEY  (`id`)
			) TYPE=MyISAM;";
	}

	if (!empty($sql)) {
		for ($a = 0; $a < count($sql); $a++) {
			$result = mysql_query($sql[$a]);
		}
	}
}

?>